<?php

namespace Drupal\synpay\Hook;

use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\Ajax\AjaxResponse;
use Drupal\Core\Ajax\HtmlCommand;

/**
 * CheckoutFormAlter.
 */
class CheckoutFormAlter {

  /**
   * Hook From Alter.
   */
  public static function hook(&$form, FormStateInterface $form_state, $form_id) {
    // Step 1 Order Information.
    if ($form['#step_id'] == 'order_information') {
    }
    // Step 2 Review.
    if ($form['#step_id'] == 'review') {
      // $form['#attached']['library'][] = 'synpay/synpay';
      // $form['#attached']['library'][] = 'synpay/cloudpayments';
      $order = \Drupal::routeMatch()->getParameters()->get('commerce_order');
      if ($order->hasField('payment_gateway')) {
        $pluginConfiguration = $order->payment_gateway->entity->getPluginConfiguration();
        if ($pluginConfiguration['mode'] == 'test') {
          $manager = \Drupal::service('plugin.manager.synpay');
          $synpay = $manager->createInstance($pluginConfiguration['gateway']);
          $text = "<b>Оплаты работают в тестовом режиме!</b><br>";
          $text .= $synpay->testCards();
          $text = "<div class='field__item'>$text</div><br>";
          $form['review']['payment_information']['summary']['payment_gateway']['#prefix'] = $text;
        }
      }
      // dsm($order);
      // $data = [
      //   'publicId' => 'pk_28d09807c1a050cbba2eddbc0e616',
      // ];
      // $form['#attached']['drupalSettings']['cloudpayments'] = $data;
      // $form['actions']['cloudpayments'] = [
      //   // '#type' => 'button',
      //   'ajax_submit' => [
      //     '#type' => 'button',
      //     '#value' => 'Оплатить',
      //     '#attributes' => ['class' => ['inline', 'btn-success', 'cloudpayments']],
      //     '#ajax'   => [
      //       'callback' => 'Drupal\synpay\Hook\CheckoutFormAlter::ajaxSubmit',
      //       'progress' => ['type' => 'throbber', 'message' => NULL],
      //     ],
      //   ],
      // ];
      // dsm($form);
    }
    // Step 3 Payment.
    if ($form['#step_id'] == 'payment') {
    }
    // Step 4 Complete.
    if ($form['#step_id'] == 'complete') {

    }
  }

  /**
   * AJAX ajaxPrev.
   */
  public static function ajaxSubmit(array &$form, $form_state) {
    $response = new AjaxResponse();
    // $response->addCommand(new CssCommand('#edit-actions-cloudpayments-ajax-submit', [
    //   'color' => '#495057',
    //   'border' => '1px solid #ced4da',
    // ]));
    // $response->addCommand(new HtmlCommand("#cdek-city-result", $text));
    return $response;
  }

}
